emulated_window = (function()
{

	var ew = {};

	var workArea = {};

	ew.setWorkArea = function(ctx) {
		workArea = ctx;	
	}	

	ew.getFontMetrics = {
		"charWidth" : function(char) {
			workArea.measureText(char).width;		
		},
		"stringWidth" : function(char) {
			workArea.measureText(char).width;		
		}
	}

	ew.drawString = function(structure) {
		var font = "";
		if (structure.fontDetails.bold) {
			font += "bold ";
		}
		if (structure.fontDetails.italic) {
			font += "italic ";
		}
		font += " " + structure.fontDetails.size + "px";
		font += " '" + structure.fontDetails.name + "'"
		workArea.font = font;
		workArea.fillText(structure.text, structure.x, structure.y);
	}

	ew.drawStringScaled = function(structure) {
		var fontSize = structure.fontDetails.legacyHeight;
		// measure the text width for the new fontSize the calculate widthScale		
		// var widthScale = structure.fontDetails.legacyHeight / structure.fontDetails.legacyHeight;
		var widthScale = 0.5;
		
		// load the font definition from FontDetails
		opentype.load('Arial.ttf', function(err, font) {
		    if (err) {
			alert('Font could not be loaded: ' + err);
		    } else {
			font.draw(workArea, structure.text, structure.x / widthScale / widthScale, structure.y, structure.fontDetails.size, 
					{"kerning" : false, "widthScale" : widthScale});
		    }
		});
	}

	return ew;

}())
